﻿using System;
using System.Windows;
using System.Windows.Controls;

namespace FlipNumberClock
{
    public partial class FlipNumber : UserControl
    {
        public static readonly DependencyProperty NumberProperty =
            DependencyProperty.Register("Number",
                typeof(int),
                typeof(FlipNumber),
                new PropertyMetadata(OnNumberChanged));

        public FlipNumber()
        {
            InitializeComponent();
        }

        public int Number
        {
            set { SetValue(NumberProperty, value); }
            get { return (int)GetValue(NumberProperty); }
        }

        static void OnNumberChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            (obj as FlipNumber).OnNumberChanged(args);
        }

        void OnNumberChanged(DependencyPropertyChangedEventArgs args)
        {
            txtblkTopFlipper.Text = args.OldValue.ToString();
            borderTopFlipper.Opacity = 1;
            txtblkTop.Text = args.NewValue.ToString();

            flipTop.Begin();
        }

        void OnTopFlipCompleted(object sender, EventArgs args)
        {
            borderTopFlipper.Opacity = 0;

            txtblkBottomFlipper.Text = Number.ToString();
            borderBottomFlipper.Opacity = 1;

            flipBottom.Begin();
        }

        void OnBottomFlipCompleted(object sender, EventArgs args)
        {
            txtblkBottom.Text = Number.ToString();
            borderBottomFlipper.Opacity = 0;
        }
    }
}
